import { ConnectionPoolAdapter } from './base/connectionPool';
import { ConnectionAdapter } from './base/connection';
import { Query, Data } from '../../../query/domain';
import { Helper } from '../../../shared/application';
import { Connection } from '../../application';
import { MappingConfigService } from '../../../schema/application';
import { DialectService } from '../../../language/application';
export declare class OracleConnectionPoolAdapter extends ConnectionPoolAdapter {
    private static lib;
    private pool;
    init(): Promise<void>;
    acquire(): Promise<Connection>;
    release(connection: Connection): Promise<void>;
    end(): Promise<void>;
}
export declare class OracleConnectionAdapter extends ConnectionAdapter {
    private readonly lib;
    constructor(lib: any, cnx: any, pool: any, helper: Helper);
    select(mapping: MappingConfigService, dialect: DialectService, query: Query, data: Data): Promise<any>;
    insert(mapping: MappingConfigService, dialect: DialectService, query: Query, data: Data): Promise<any>;
    bulkInsert(mapping: MappingConfigService, dialect: DialectService, query: Query, array: any[]): Promise<any[]>;
    update(mapping: MappingConfigService, dialect: DialectService, query: Query, data: Data): Promise<number>;
    delete(mapping: MappingConfigService, dialect: DialectService, query: Query, data: Data): Promise<number>;
    execute(query: Query): Promise<any>;
    executeDDL(query: Query): Promise<any>;
    executeSentence(sentence: any): Promise<any>;
    beginTransaction(): Promise<void>;
    commit(): Promise<void>;
    rollback(): Promise<void>;
    protected arrayToRows(_mapping: MappingConfigService, _dialect: DialectService, query: Query, array: any[]): any[];
    private getQueryInfo;
    private getAutoIncrementInfo;
    private oracleType;
    private getOracleType;
    private getItemValue;
}
