import { SchemaFacade } from '../../../../schema/application';
import { Query, Data, QueryOptions } from '../../../../query/domain';
import { Helper } from '../../../../shared/application';
import { ConnectionFacade } from '../../../../connection/application';
import { LanguagesService } from '../../../../language/application';
import { Expressions } from '3xpr';
import { IQueryInternalExecutor } from './iQueryInternalExecutor';
export declare class QueryExecutor implements IQueryInternalExecutor {
    private readonly connectionFacade;
    private readonly languages;
    private readonly schemaFacade;
    private readonly expressions;
    readonly options: QueryOptions;
    private readonly helper;
    private transactional;
    private connections;
    private selectExecutor;
    private insertExecutor;
    private bulkInsertExecutor;
    private updateExecutor;
    private deleteExecutor;
    constructor(connectionFacade: ConnectionFacade, languages: LanguagesService, schemaFacade: SchemaFacade, expressions: Expressions, options: QueryOptions, helper: Helper, transactional?: boolean);
    private getConnection;
    commit(): Promise<void>;
    rollback(): Promise<void>;
    release(): Promise<void>;
    execute(query: Query, data: any): Promise<any>;
    _execute(query: Query, data: Data): Promise<any>;
}
