import { Query, Data, QueryOptions } from '../../../../query/domain';
import { Helper } from '../../../../shared/application';
import { Connection } from '../../../../connection/application';
import { DialectService } from '../../../../language/application';
import { MappingConfigService } from '../../../../schema/application/services/config/mappingConfigService';
import { Expressions } from '3xpr';
import { IQueryInternalExecutor } from './iQueryInternalExecutor';
export declare class QuerySelectExecutor {
    private readonly executor;
    readonly options: QueryOptions;
    private readonly helper;
    private solveReadValues;
    constructor(executor: IQueryInternalExecutor, expressions: Expressions, options: QueryOptions, helper: Helper);
    select(query: Query, data: Data, mapping: MappingConfigService, dialect: DialectService, connection: Connection): Promise<any>;
    private selectIncludes;
    private selectInclude;
    private selectClearTemporalFields;
    private selectChunkResult;
    private selectChunkIds;
    private selectChild;
    private selectChildSetManyToOne;
    private selectChildSetOneToMany;
}
