"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GetInfoQuery = void 0;
class GetInfoQuery {
    // eslint-disable-next-line no-useless-constructor
    constructor(builder) {
        this.builder = builder;
    }
    getInfo(expression, options) {
        const query = this.builder.build(expression, options);
        return this._getInfo(query);
    }
    _getInfo(query) {
        var _a;
        const mainSentence = { entity: query.entity, dialect: query.dialect, source: query.source, sentence: query.sentence, children: [] };
        for (const p in query.includes) {
            const include = query.includes[p];
            const includeSentence = this._getInfo(include.query);
            (_a = mainSentence.children) === null || _a === void 0 ? void 0 : _a.push(includeSentence);
        }
        return mainSentence;
    }
}
exports.GetInfoQuery = GetInfoQuery;
//# sourceMappingURL=getInfo.js.map