"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.StageConfigService = void 0;
const domain_1 = require("../../../domain");
class StageConfigService {
    constructor() {
        this.stages = [];
    }
    load(value) {
        if (value && value.name) {
            const index = this.stages.findIndex(p => p.name === value.name);
            if (index === -1) {
                this.stages.push(value);
            }
            else {
                this.stages[index] = value;
            }
        }
    }
    get(name) {
        if (name === undefined) {
            return this.stages[0];
        }
        const stage = this.stages.find(p => p.name === name);
        if (stage === undefined) {
            throw new domain_1.SchemaError(`Stage: ${name} not found`);
        }
        return stage;
    }
}
exports.StageConfigService = StageConfigService;
//# sourceMappingURL=stageConfigService.js.map