"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ViewConfigService = void 0;
class ViewConfigService {
    constructor(view) {
        this.view = view;
    }
    get name() {
        return this.view.name;
    }
    get() {
        return this.view;
    }
    set(value) {
        this.view = value;
    }
    get entities() {
        return this.view.entities ? this.view.entities : [];
    }
    getEntity(name) {
        return this.view.entities ? this.view.entities.find(p => p.name === name) : undefined;
    }
    getProperty(entityName, name) {
        const entity = this.getEntity(entityName);
        if (!entity) {
            return undefined;
        }
        return entity.properties ? entity.properties.find(p => p.name === name) : undefined;
    }
    excludeEntity(name) {
        const entity = this.getEntity(name);
        return entity ? !!entity.exclude : false;
    }
}
exports.ViewConfigService = ViewConfigService;
//# sourceMappingURL=viewConfigService.js.map