"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SentenceLibrary = void 0;
const CryptoJS = require('crypto-js');
class SentenceLibrary {
    load(model) {
        this.functions(model);
    }
    functions(model) {
        model.addFunction('toBase64(value:string):string', (value) => CryptoJS.enc.Base64.parse(value));
        model.addFunction('getBase64(value:string):string', (value) => CryptoJS.enc.Base64.stringify(value));
        model.addFunction('encrypt(value:string):string', (value, key) => CryptoJS.AES.encrypt(value, key).toString());
        model.addFunction('decrypt(value:string):string', (value, key) => CryptoJS.AES.decrypt(value, key).toString(CryptoJS.enc.Utf8));
        model.addFunction('update(list: any[], predicate: any):any', () => { throw new Error('NotImplemented'); });
        model.addFunction('updateAll(list: any[], predicate: any):any', () => { throw new Error('NotImplemented'); });
        model.addFunction('deleteAll(list: any[]):any', () => { throw new Error('NotImplemented'); });
        model.addFunction('having(list: T[], predicate: boolean):T[]', () => { throw new Error('NotImplemented'); });
        model.addFunction('include(list: any[], predicate: any):any', () => { throw new Error('NotImplemented'); });
        model.addFunction('desc(value:any):void', () => { throw new Error('NotImplemented'); });
        model.addFunction('asc(value:any):void', () => { throw new Error('NotImplemented'); });
    }
}
exports.SentenceLibrary = SentenceLibrary;
//# sourceMappingURL=library.js.map