"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.NotImplemented = exports.MethodNotImplemented = exports.SintaxisError = void 0;
class SintaxisError extends Error {
    constructor(message) {
        super(message);
        this.name = 'SintaxisError';
    }
}
exports.SintaxisError = SintaxisError;
class MethodNotImplemented extends Error {
    constructor(_class, method) {
        super(`method ${method} in class: ${_class} not implemented`);
        this.name = 'MethodNotImplemented';
    }
}
exports.MethodNotImplemented = MethodNotImplemented;
class NotImplemented extends Error {
    constructor(message) {
        super(message);
        this.name = 'NotImplemented';
    }
}
exports.NotImplemented = NotImplemented;
//# sourceMappingURL=error.js.map